sc::MBPT2(3)

NAME
sc::MBPT2 -

The MBPT2 class implements several second-order perturbation theory methods.

SYNOPSIS

#include <mbpt.h>

Inherits sc::Wavefunction.

Inherited by sc::MBPT2_R12.

  Public Member Functions
MBPT2 (StateIn &)
MBPT2 (const Ref< KeyVal > &)
The KeyVal constructor.
void save_data_state (StateOut &)
Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
Ref< SCF > ref ()
double ref_energy ()
double corr_energy ()
RefSCVector ref_energy_gradient ()
RefSCVector corr_energy_gradient ()
int nelectron ()
Returns the number of electrons.
int nfzcore () const
int nfzvirt () const
RefSymmSCMatrix density ()
Returns the SO density.
int spin_polarized ()
Return 1 if the alpha density is not equal to the beta density.
int gradient_implemented () const
int value_implemented () const
Information about the availability of values, gradients, and hessians.
void symmetry_changed ()
Call this if you have changed the molecular symmetry of the molecule contained by this MolecularEnergy.
void obsolete ()
Marks all results as being out of date.
void print (std::ostream &o=ExEnv::out0()) const
Print information about the object.

  Protected Member Functions
void init_variables ()
void compute ()
Recompute at least the results that have compute true and are not already computed.
void eigen (RefDiagSCMatrix &vals, RefSCMatrix &vecs, RefDiagSCMatrix &occs)
void compute_hsos_v1 ()
distsize_t compute_v2_memory (int ni, int nfuncmax, int nbfme, int nshell, int ndocc, int nsocc, int nvir, int nproc)
void compute_hsos_v2 ()
void compute_hsos_v2_lb ()
int compute_cs_batchsize (size_t mem_static, int nocc_act)
distsize_t compute_cs_dynamic_memory (int ni, int nocc_act)
int make_cs_gmat (RefSymmSCMatrix &Gmat, double *DPmat)
int make_cs_gmat_new (RefSymmSCMatrix &Gmat, const RefSymmSCMatrix &DPmat)
void form_max_dens (double *DPmat, signed char *maxp)
int init_cs_gmat ()
void done_cs_gmat ()
int make_g_d_nor (RefSymmSCMatrix &Gmat, double *DPmat, const double *mgdbuff)
void cs_cphf (double **scf_vector, double *Laj, double *eigval, RefSCMatrix &P2aj)
void s2pdm_contrib (const double *intderbuf, double *PHF, double *P2AO, double **hf_ginter, double **ginter)
void hcore_cs_grad (double *PHF, double *PMP2, double **hf_ginter, double **ginter)
void overlap_cs_grad (double *WHF, double *WMP2, double **hf_ginter, double **ginter)
void compute_cs_grad ()

  Protected Attributes
Ref< SCF > reference_
Ref< MemoryGrp > mem
int nfzc
int nfzv
size_t mem_alloc
double cphf_epsilon_
int eliminate_in_gmat_
const double * intbuf_
Ref< TwoBodyInt > tbint_
Ref< TwoBodyInt > * tbints_
Ref< TwoBodyDerivInt > * tbintder_
int nbasis
int noso
Ref< MessageGrp > msg_
int nvir
int nocc
int nsocc
Ref< ThreadGrp > thr_
int dynamic_
double print_percent_
int max_norb_
int * symorb_irrep_
int * symorb_num_
char * method_
char * algorithm_
int do_d1_
int do_d2_
int nfuncmax
double hf_energy_
RefSCVector hf_gradient_
double restart_ecorr_
int restart_orbital_v1_
int restart_orbital_memgrp_

Detailed Description

The MBPT2 class implements several second-order perturbation theory methods.

Constructor & Destructor Documentation

  sc::MBPT2::MBPT2 (const Ref< KeyVal > &)

The KeyVal constructor. .IP "reference" 1c This gives the reference wavefunction. It must be an object of type CLSCF for closed-shell molecules and HSOSSCF for open-shell molecules. The is no default.

nfzc
    The number of frozen core orbitals. The default is 0. If no atoms have an atomic number greater than 30, then the number of orbitals to be frozen can be automatically determined by specifying nfzc = auto.

nfzv
    The number of frozen virtual orbitals. The default is 0.

memory
    The amount of memory, in bytes, that each processor may use.

method
    This gives a string that must take on one of the values below. The default is mp for closed-shell systems and zapt for open-shell systems.

mp  Use Moller-Plesset perturbation theory. This is only valid for closed-shell systems. Energies and gradients can be computed with this method.

opt1
    Use the OPT1 variant of open-shell perturbation theory. Only energies can be computed for open-shell systems.

opt2
    Use the OPT2 variant of open-shell perturbation theory. Only energies can be computed for open-shell systems.

zapt
    Use the ZAPT variant of open-shell perturbation theory. Only energies can be computed for open-shell systems.

algorithm
    This gives a string that must take on one of the values given below. The default is memgrp for closed-shell systems. For open-shell systems v1 is used for a small number of processors and v2 is used otherwise.

memgrp
    Use the distributed shared memory algorithm (which uses a MemoryGrp object). This is only valid for MP2 energies and gradients.

v1  Use algorithm V1. Only energies can be computed. The maximum number of processors that can be utilized is the number of virtual orbitals. This algorithm computes few integrals than the others, but has higher communication requirements.

v2  Use algorithm V2. Only energies can be computed. The maximum number of processors that can be utilized is the number of shells.

v2lb
    Use a modified V2 algorithm that may compute more two electron integrals, but may get better load balance on the $O(n_thrm{basis}^5)$ part of the calculation. Only energies can be computed. This is recommended only for computations involving large molecules (where the transformation is dominant) on very many processors (approaching the number of shells).

The v1 and v2 algorithms are discussed in Ida M. B. Nielsen and Edward T. Seidl, J. Comp. Chem. 16, 1301 (1995). The memgrp algorithm is discussed in Ida M. B. Nielsen, Chem. Phys. Lett. 255, 210 (1996).

memorygrp
    A MemoryGrp object is used by the memgrp algorithm. If this is not given the program will try to find an appropriate default.

Member Function Documentation

  void sc::MBPT2::compute () [protected, virtual]

Recompute at least the results that have compute true and are not already computed. This should only be called by Result's members.

Implements sc::Compute.

Reimplemented in sc::MBPT2_R12.

  void sc::MBPT2::obsolete () [virtual]

Marks all results as being out of date. Any subsequent access to results will cause Compute::compute() to be called.

Reimplemented from sc::Wavefunction.

Reimplemented in sc::MBPT2_R12.

  void sc::MBPT2::save_data_state (StateOut &) [virtual]

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. This must be implemented by the derived class if the class has data.

Reimplemented from sc::Wavefunction.

Reimplemented in sc::MBPT2_R12.

  void sc::MBPT2::symmetry_changed () [virtual]

Call this if you have changed the molecular symmetry of the molecule contained by this MolecularEnergy.

Reimplemented from sc::Wavefunction.

  int sc::MBPT2::value_implemented () const [virtual]

Information about the availability of values, gradients, and hessians.

Reimplemented from sc::Function.

Reimplemented in sc::MBPT2_R12.

Author

Generated automatically by Doxygen for MPQC from the source code.